'use strict';

var fs = require("fire-fs");
var path = require("fire-path");

module.exports = {
    load: function () {
        // 当 package 被正确加载的时候执行
    },

    unload: function () {
        // 当 package 被正确卸载的时候执行
    },

    messages: {
        'editor:build-finished': function (event, target) {

            var fullPath = function(dir, files) {
                return files.map(function (f) {
                    return path.join(dir, f);
                });
            }

            var eachFileSync = function(dir, findOne) {
                var stats = fs.statSync(dir);
                findOne(dir, stats);
            
                // 遍历子目录
                if (stats.isDirectory()) {
                    var files = fullPath(dir, fs.readdirSync(dir));
            
                    files.forEach(function (f) {
                        eachFileSync(f, findOne);
                    });
                }
            }

            var rmJsonDir = function(path) {
                var files = [];
                if( fs.existsSync(path) ) {
                    files = fs.readdirSync(path);
                    files.forEach(function(file,index){
                        var curPath = path + "/" + file;
                        if(fs.statSync(curPath).isDirectory()) {
                            rmJsonDir(curPath);
                        } else {
                            var index = curPath.lastIndexOf(".");
                            var ext = curPath.substr(index);
                            if (ext == '.json'){
                                fs.unlinkSync(curPath);
                            }
                        }
                    });
                    files = fs.readdirSync(path);
                    if (files.length <= 0){
                        fs.rmdirSync(path);
                    }
                }
            }

            var root = path.normalize(target.dest);
            var mainJsPath = path.join(root, "main.js");
            var jsonFilesPath = path.join(root,'res/import');
            var mergeFileName = 'resJsons.js';
            var savePath = path.join(root,"src",mergeFileName);
            var jsonFiles = [];
            if( fs.existsSync(path) ) {
                eachFileSync(jsonFilesPath, function (f, s) {
                    if(!fs.statSync(f).isDirectory()) {
                        var index = f.lastIndexOf(".");
                        var ext = f.substr(index);
                        // Editor.log('file:ext %s', ext);
                        if (ext == '.json'){
                            // Editor.log('file: %s', f);
                            jsonFiles.push(f);
                        }
                    }
                });
            }
            var jsonData = {};
            for(var i=0;i<jsonFiles.length;++i){
                var index = jsonFiles[i].lastIndexOf("/");
                var name = jsonFiles[i].substr(index+1);
                jsonData[name] = fs.readFileSync(jsonFiles[i], "utf-8");
            }
            var dataStr = JSON.stringify(jsonData);
            dataStr = "cc.resJsons = " + dataStr;
            fs.writeFileSync(savePath, dataStr);
            
            // for (var i=0;i<jsonFiles.length;++i){
            //     fs.unlinkSync(jsonFiles[i]);
            // }

            rmJsonDir(jsonFilesPath);
            
            var newStr = "\n"+
            "       if (jsList) {\n"+
            "           jsList.push('"+mergeFileName+"');\n"+
            "       }\n"+
            "       jsList = jsList.map(function (x) { return 'src/' + x; });\n";

            var newStr2 = "(function () {\n"+
            "    if (cc.sys.isNative) {\n"+
            "        jsb.fileUtils.getResJsonStringFromFile = jsb.fileUtils.getStringFromFile;\n"+
            "        jsb.fileUtils.getStringFromFile = function(url){\n"+
            "            var getCCCJsonFile = function(jsonUrl){\n"+
            "                var index = jsonUrl.lastIndexOf('/');\n"+
            "                var name = jsonUrl.substr(index+1);\n"+
            "                var index = name.lastIndexOf('.');\n"+
            "                var ext = name.substr(index);\n"+
            "                if (ext == '.json'){\n"+
            "                    if (cc.resJsons){\n"+
            "                        return cc.resJsons[name];\n"+
            "                    }\n"+
            "                }\n"+
            "            }\n"+
            "            var jsonData = getCCCJsonFile(url);\n"+
            "            if(jsonData){\n"+
            "                return jsonData;\n"+
            "            }\n"+
            "            return jsb.fileUtils.getResJsonStringFromFile(url);\n"+
            "        }\n"+
            "    }\n";

            var mainJsData = fs.readFileSync(mainJsPath, "utf-8");
            var newData = mainJsData.replace("jsList = jsList.map(function (x) { return 'src/' + x; });", newStr);
            var newData = newData.replace("(function () {", newStr2);
            fs.writeFileSync(mainJsPath, newData);
            Editor.log('mergeJson end');
        },
    },
};